package BoidGui;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author TALAL ALANIZI
 */
public class BoidGui extends JFrame {
    private static BoidGui bg;
    private static BoidFlock boidFlock;
    private static JPanel buttons;

    public static void main(String[] args) {
        bg=new BoidGui();
        boidFlock=new BoidFlock(5);
        bg.init();
        while (true) {
            bg.repaint();
        }

    }

    public void init(){
        buttons=new JPanel();
        bg.setLayout(null);
        bg.add(buttons);

        bg.setBounds(0, 0, BoidFlock.BOARDS, BoidFlock.BOARDS+350);
        buttons.setLayout(new GridLayout(0, 3));
        JButton button1=new JButton("add");
        button1.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boidFlock.addBoidToFlock();
            }
        });
        JButton button2=new JButton("remove");
        button2.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boidFlock.removeBoidFromFlock();
            }
        });
        JButton button3=new JButton("clear");
        button3.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boidFlock.destroyAllBoids();
            }
        });
        buttons.add(button1);
        buttons.add(button2);
        buttons.add(button3);
        buttons.setBounds(0,BoidFlock.BOARDS,BoidFlock.BOARDS,100);

        JSlider detectRad =new JSlider(0,100);
        bg.add(detectRad);
        detectRad.setBounds(0,BoidFlock.BOARDS+100,BoidFlock.BOARDS,50);
        Hashtable labelTable = new Hashtable();
        labelTable.put( new Integer( 0 ), new JLabel("Small detect radius") );
        labelTable.put( new Integer(100), new JLabel("Big detect radius") );
        detectRad.setLabelTable(labelTable);
        detectRad.setPaintLabels(true);

        JSlider separation =new JSlider(0,100);
        bg.add(separation);
        separation.setBounds(0,BoidFlock.BOARDS+150,BoidFlock.BOARDS,50);
        Hashtable labelTable2 = new Hashtable();
        labelTable2.put( new Integer( 0 ), new JLabel("Small separation") );
        labelTable2.put( new Integer(100), new JLabel("Big separation") );
        separation.setLabelTable(labelTable2);
        separation.setPaintLabels(true);

        JSlider alignment =new JSlider(0,100);
        bg.add(alignment);
        alignment.setBounds(0,BoidFlock.BOARDS+200,BoidFlock.BOARDS,50);
        Hashtable labelTable3 = new Hashtable();
        labelTable3.put( new Integer( 0 ), new JLabel("Small alignment") );
        labelTable3.put( new Integer(100), new JLabel("Big alignment") );
        alignment.setLabelTable(labelTable3);
        alignment.setPaintLabels(true);

        JSlider conesion =new JSlider(0,100);
        bg.add(conesion);
        conesion.setBounds(0,BoidFlock.BOARDS+250,BoidFlock.BOARDS,50);
        Hashtable labelTable4 = new Hashtable();
        labelTable4.put( new Integer( 0 ), new JLabel("Small conesion") );
        labelTable4.put( new Integer(100), new JLabel("Big conesion") );
        conesion.setLabelTable(labelTable4);
        conesion.setPaintLabels(true);

        detectRad.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                boidFlock.setDetectradius(((JSlider)(e.getSource())).getValue());
            }
        });

        separation.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
              Boid.SEPARATION_WEIGHT=(((JSlider)(e.getSource())).getValue()/50f);
            }
        });

        alignment.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                Boid.ALIGNMENT_WEIGHT=(((JSlider)(e.getSource())).getValue()/1000f);
            }
        });

        conesion.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                Boid.COHESION_WEIGHT=(((JSlider)(e.getSource())).getValue()/5000f);
            }
        });
        setTitle("Boid");
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        bg.setVisible(true);
    }

    @Override
    public void paint(Graphics g) {
        boidFlock.drawAllBoids(g);
        super.paint(g);
    }
}
