//insert method O(n)
//remove method O(n)
package BoidGui;
import java.util.ArrayList;
import java.util.NoSuchElementException;
import java.util.Random;


/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author TALAL ALANIZI
 */
public class RandomObtainable<E> extends ArrayList<E> {
    public E getRandom(){
        if(isEmpty()) throw new NoSuchElementException();
       return get(new Random().nextInt(size()));
    }

    public boolean removeRandom(){
        return remove(getRandom());
    }

    public boolean insertRandom(E element){
        add(new Random().nextInt(size()+1),element);
        return contains(element);
    }
}
